curl_multi_wait(3)

NAME
curl_multi_select - polls on all easy handles in a multi handle

SYNOPSIS
#include <curl/curl.h>
CURLMcode curl_multi_wait(CURLM *multi_handle,
                          struct curl_waitfd extra_fds[],
                          unsigned int extra_nfds,
                          int timeout_ms);

DESCRIPTION
This function polls on all file descriptors used by the curl easy handles contained in the given multi handle set. It will block until activity is detected on at least one of the handles or timeout_ms has passed. The calling application may pass additional curl_waitfd structures which are similar to poll(2)'s pollfd structure to be waited on in the same call. This function is encouraged to be used instead of select(3) when using the multi interface to allow applications to easier circumvent the common problem with 1024 maximum file descriptors.

curl_waitfd
struct curl_waitfd {
  curl_socket_t fd;
  short events;
  short revents;
};

CURL_WAIT_POLLIN
    Bit flag to curl_waitfd.events indicating the socket should poll on read events such as new data received.

CURL_WAIT_POLLPRI
    Bit flag to curl_waitfd.events indicating the socket should poll on high priority read events such as out of band data.

CURL_WAIT_POLLOUT
    Bit flag to curl_waitfd.events indicating the socket should poll on write events such as the socket being clear to write without blocking.

RETURN VALUE
CURLMcode type, general libcurl multi interface error code. See libcurl-errors(3)

AVAILABILITY
This function was added in libcurl 7.28.0

SEE ALSO
curl_multi_fdset(3), curl_multi_perform(3)